=== Plugin-AlignMeshes/CMakeLists.txt ===
include (plugin)
openflipper_plugin(DIRS Widgets DEPS OpenMesh EIGEN3)
