=== Plugin-Backup/CMakeLists.txt ===
include (plugin)
openflipper_plugin(INSTALLDATA VsiMetadata)
