=== Plugin-Color/CMakeLists.txt ===
include (plugin)
openflipper_plugin ( TRANSLATION_LANGUAGES de_DE 
                     INSTALLDATA Icons VsiMetadata)
