=== Plugin-Components/CMakeLists.txt ===
include (plugin)

openflipper_plugin ( INSTALLDATA Icons )
