=== Plugin-DeserializeScreenshotMetadata/CMakeLists.txt ===
include (plugin)

openflipper_plugin (DIRS
			INSTALLDATA Icons
		    )
