=== Plugin-GaussCurvature/CMakeLists.txt ===
include (plugin)
openflipper_plugin ()
