=== Plugin-INI/CMakeLists.txt ===
include (plugin)

openflipper_plugin (  )
