=== debian/control ===
Source: openflipper
Section: unknown
Priority: extra
Maintainer: Jan Möbius <moebius@adenauer.informatik.rwth-aachen.de>
Build-Depends: debhelper (>= 8.0.0), cdbs, cmake, libqt4-dev, libqt4-opengl-dev, libglew1.6-dev, libxmu-dev, libxi-dev, freeglut3-dev, libfreetype6-dev, libgomp1, doxygen
Standards-Version: 3.9.2
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://git.debian.org/collab-maint/openflipper.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/openflipper.git;a=summary

Package: openflipper
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Geometry modeling System
 System to manipulate geometry models
