=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1


include /usr/share/cdbs/1/class/cmake.mk 
include /usr/share/cdbs/1/rules/debhelper.mk

RPATH := Build/lib/OpenFlipper/ 
DEB_CMAKE_EXTRA_FLAGS := -DBLOCK_IN_SOURCE_BUILD=OFF -DCMAKE_BUILD_TYPE=Release

install/openflipper::
	dh_install -popenflipper debian/openflipper/usr/lib/OpenFlipper/libACG* /usr/lib
	dh_install -popenflipper debian/openflipper/usr/lib/OpenFlipper/libPluginLib.so /usr/lib
